/* GNU polyxmass - the massist's program.
   -------------------------------------- 
   Copyright (C) 2000,2001,2002 Filippo Rusconi

   http://www.polyxmass.org

   This file is part of the "GNU polyxmass" project.
   
   The "GNU polyxmass" project is an official GNU project package (see
   www.gnu.org) released ---in its entirety--- under the GNU General
   Public License and was started at the Centre National de la
   Recherche Scientifique (FRANCE), that granted me the formal
   authorization to publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU  General Public
   License along with this software; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef PXMCHEM_LEFTRIGHTRULE_H
#define PXMCHEM_LEFTRIGHTRULE_H

#include "pxmchem-globals.h"
#include "pxmchem-monomer.h"
#include "pxmchem-poldef.h"
#include "pxmchem-formula.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/* typedef's
 */
typedef struct _PxmLRrule PxmLRrule;

struct _PxmLRrule
{
  gchar *left_code;

  gchar *left_actform;	

  gchar *right_code;

  gchar *right_actform;	
};



/* NEW'ING FUNCTIONS, DUPLICATING FUNCTIONS, INITING FUNCTIONS ...
 */
PxmLRrule * 
pxmchem_leftrightrule_new (void);


PxmLRrule * 
pxmchem_leftrightrule_dup (const PxmLRrule * lrr);


gboolean
pxmchem_leftrightrule_set_left_code (PxmLRrule * lrr,
				     gchar *left_code);
  

gboolean
pxmchem_leftrightrule_set_right_code (PxmLRrule *lrr,
				      gchar *right_code);
  

gboolean
pxmchem_leftrightrule_set_left_actform (PxmLRrule *lrr,
					gchar *left_actform);
  

gboolean
pxmchem_leftrightrule_set_right_actform (PxmLRrule *lrr,
					 gchar *right_actform);
  


/* INTEGRITY CHECKING FUNCTIONS
 */
gboolean
pxmchem_leftrightrule_validate (PxmLRrule *lrr, gchar *delim_codes, 
				gchar **valid);



/* XML-format TRANSACTIONS
 */
gchar *
pxmchem_leftrightrule_format_xml_string_lrr (PxmLRrule *lrr, 
					 gchar *indent, gint offset);
  

PxmLRrule *
pxmchem_leftrightrule_render_xml_node_lrr (xmlDocPtr xml_doc,
				       xmlNodePtr xml_node,
				       gpointer user_data);



/* FREE'ING FUNCTIONS
 */
gboolean
pxmchem_leftrightrule_free (PxmLRrule * lrr);



/* GPtrArray-RELATED FUNCTIONS
 */
gint
pxmchem_leftrightrule_GPA_free (GPtrArray *GPA);




#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* PXMCHEM_LEFTRIGHTRULE_H */
